// $Header: //depot/acad/develop/global/src/arxsdk/modules/AsdkHlrApi/Samples/HlrArxCustom/Pie/arx.cpp#2 $ $Change: 293540 $ $DateTime: 2012/01/03 10:55:53 $ $Author: patti $
// $NoKeywords: $
//
//////////////////////////////////////////////////////////////////////////////
//
//  Copyright 2012 Autodesk, Inc.  All rights reserved.
//
//  Use of this software is subject to the terms of the Autodesk license 
//  agreement provided at the time of installation or download, or which 
//  otherwise accompanies this software in either electronic or hard copy form.   
//
//////////////////////////////////////////////////////////////////////////////


#include "acgi.h"
#include "geassign.h"

#include "dbid.h"
#include "dbmain.h"
#include "dbapserv.h"
#include "dbsymtb.h"
#include "rxboiler.h"

#include "tools.h"
#include "2dsector.h"

//--------------------------------------------------------------------------
extern "C" AcRx::AppRetCode acrxEntryPoint (AcRx::AppMsgCode msg, void *pkt) {
	switch ( msg ) {
		case AcRx::kInitAppMsg:
			acrxDynamicLinker->unlockApplication (pkt) ;

            acrxDynamicLinker->registerAppMDIAware(pkt);

			Asdk2dSector::rxInit () ;
			acrxBuildClassHierarchy () ;

			acrxDynamicLinker->registerService (AsdkPieServiceName, new AcRxService) ;

			break ;
		case AcRx::kUnloadAppMsg:
			delete acrxServiceDictionary->remove (AsdkPieServiceName) ;

			deleteAcRxClass (Asdk2dSector::desc ()) ;

			break ;
	}
	return (AcRx::kRetOK) ;
}
